use uinput::event::relative;
use uinput::event::controller::Mouse;

pub struct VirtualMouse {
    pub device: uinput::Device,
}

impl VirtualMouse {
    pub fn new(name: &str) -> Self {
        let virt_mouse = uinput::default().unwrap()
            .name(name).unwrap()
            .event(Mouse::Left).unwrap()
            .event(Mouse::Right).unwrap()
            .event(Mouse::Middle).unwrap()
            .event(Mouse::Side).unwrap()
            .event(Mouse::Extra).unwrap()
            .event(relative::Position::X).unwrap()
            .event(relative::Position::Y).unwrap()
            .event(relative::Wheel::Vertical).unwrap()
            .event(relative::Wheel::Horizontal).unwrap()
            .create().unwrap();

        VirtualMouse {
            device: virt_mouse
        }
    }
}
